diff -NarU2 a/copyparty/web/tl/tur.js b/copyparty/web/tl/tur.js
--- a/copyparty/web/tl/tur.js	2026-07-08 15:13:32.823924491 +0000
+++ b/copyparty/web/tl/tur.js	2026-07-28 23:09:10.627683979 +0000
@@ -6,5 +6,5 @@
 
 	"cols": {
-		"c": "işlem butonları",
+		"!": "işlem butonları",
 		"dur": "süre",
 		"q": "kalite / bitrate",
@@ -15,5 +15,5 @@
 		"Vhash": "video denetim toplamı",
 		"Res": "çözünürlük",
-		"T": "dosya türü",
+		"Ext": "dosya türü",
 		"aq": "ses kalitesi / bitrate",
 		"vq": "video kalitesi / bitrate",
@@ -34,5 +34,5 @@
 			["T", "küçük resimler / simgeler arasında geçiş yap"],
 			["⇧ A/D", "küçük resim boyutu"],
-			["ctrl-K", "seçileni sil"],
+			["ctrl-K/Del", "seçileni sil"],
 			["ctrl-X", "seçimi panoya kes"],
 			["ctrl-C", "seçimi panoya kopyala"],
@@ -108,7 +108,7 @@
 
 	"goh": "kontrol paneli",
-	"gop": 'önceki kardeş">önceki',
-	"gou": 'üst klasör">üst',
-	"gon": 'sonraki klasör">sonraki',
+	"gop": 'önceki kardeş',
+	"gou": 'üst klasör',
+	"gon": 'sonraki klasör',
 	"logout": "Çıkış ",
 	"login": "Giriş",
@@ -158,5 +158,5 @@
 	"ut_ow": "sunucudaki mevcut dosyaları üzerine yazmak mı?$N🛡️: asla (yerine yeni bir dosya adı oluşturur)$N🕒: sunucu dosyası sizinkinden daha eskiyse üzerine yaz$N♻️: dosyalar farklıysa her zaman üzerine yaz$N⏭️: mevcut tüm dosyaları koşulsuz atla", //m
 	"ut_mt": "yükleme yaparken diğer dosyaların hash'lenmesini durdur$N$kötü bir CPU veya HDD'ye sahipseniz kullanabilirsiniz.",
-	"ut_ask": 'yüklemeye başlamadan önce doğrulama mesajı göster">💭',
+	"ut_ask": 'yüklemeye başlamadan önce doğrulama mesajı göster',
 	"ut_pot": "arayüzü daha az karmaşık hale getirerek$Nyükleme hızını yavaş cihazlarda artır",
 	"ut_srch": "gerçekten yükleme yapma, bunun yerine dosyaların $N sunucuda var olup olmadığını kontrol et (okuma izniniz olan tüm klasörleri tarar)",
@@ -226,5 +226,5 @@
 	"ct_grid": '田 ızgara',
 	"ct_ttips": '◔ ◡ ◔">ℹ️ ipuçları',
-	"ct_thumb": 'ızgara görünümünde, simgeler ve küçük resimler arasında geçiş yapın$NKısayol: T">🖼️ küçük resimler',
+	"ct_thumb": 'simgeler ve küçük resimler arasında geçiş yapın$NKısayol: T">🖼️ küçük resimler',
 	"ct_csel": 'ızgara görünümünde dosya seçimi için CTRL ve SHIFT tuşlarını kullanın">seç',
 	"ct_dsel": 'ızgara görünümünde sürükleyerek seçimi kullanın">sürükle', //m
@@ -289,7 +289,7 @@
 	"ml_ss": "sessizliği atla", //m
 
-	"mt_loop": "bir şarkıyı döngüye al / tekrar et\">🔁",
+	"mt_loop": "bir şarkıyı döngüye al / tekrar et",
 	"mt_one": "bir şarkıdan sonra dur\">1️⃣",
-	"mt_shuf": "klasörlerdeki şarkıları karıştır\">🔀",
+	"mt_shuf": "klasörlerdeki şarkıları karıştır",
 	"mt_aplay": "sunucuya erişmek için kullandığın bağlantıda geçerli bir şarkı varsa otomatik oynat$N$Nbunu etkisiz kılmak aynı zamanda müzik oynatıldığında sayfa URL'nin değişmesini de engeller\">a▶",
 	"mt_preload": "aralıksız oynatma için sıradaki şarkıyı önceden yüklemeye başla\">ön yükleme",
@@ -306,6 +306,6 @@
 	"mt_compact": "kompakt kontroller\">⟎",
 	"mt_uncache": "önbelleği temizle &nbsp;(bunu, tarayıcınızın bozuk bir şarkı kopyasını önbelleğe alması nedeniyle çalmayı reddettiğinde deneyin)\">önbelleği temizle",
-	"mt_mloop": "açık klasörü döngüye al\">🔁 döngü",
-	"mt_mnext": "bir sonraki klasörü yükle ve devam et\">📂 sonraki",
+	"mt_mloop": "açık klasörü döngüye al",
+	"mt_mnext": "bir sonraki klasörü yükle ve devam et",
 	"mt_mstop": "oynatmayı durdur\">⏸ durdur",
 	"mt_cflac": "flac / wav'ı {0}'a dönüştür\">flac",
diff -NarU2 a/copyparty/web/tl/ukr.js b/copyparty/web/tl/ukr.js
--- a/copyparty/web/tl/ukr.js	2026-07-08 15:13:32.823924491 +0000
+++ b/copyparty/web/tl/ukr.js	2026-07-28 23:09:10.627915206 +0000
@@ -6,5 +6,5 @@
 
 	"cols": {
-		"c": "кнопки дій",
+		"!": "кнопки дій",
 		"dur": "тривалість",
 		"q": "якість / бітрейт",
@@ -15,5 +15,5 @@
 		"Vhash": "контрольна сума відео",
 		"Res": "роздільність",
-		"T": "тип файлу",
+		"Ext": "тип файлу",
 		"aq": "якість аудіо / бітрейт",
 		"vq": "якість відео / бітрейт",
@@ -34,5 +34,5 @@
 			["T", "перемкнути мініатюри / іконки"],
 			["⇧ A/D", "розмір мініатюр"],
-			["ctrl-K", "видалити вибране"],
+			["ctrl-K/Del", "видалити вибране"],
 			["ctrl-X", "вирізати до буфера"],
 			["ctrl-C", "копіювати до буфера"],
@@ -108,7 +108,7 @@
 
 	"goh": "панель керування",
-	"gop": 'попередній сусід">назад',
-	"gou": 'батьківська папка">вгору',
-	"gon": 'наступна папка">далі',
+	"gop": 'попередній сусід',
+	"gou": 'батьківська папка',
+	"gon": 'наступна папка',
 	"logout": "Вийти ",
 	"login": "увійти", //m
@@ -158,5 +158,5 @@
 	"ut_ow": "перезаписати існуючі файли на сервері?$N🛡️: ніколи (замість цього створить нове ім'я файлу)$N🕒: перезаписати, якщо файл на сервері старіший за ваш$N♻️: завжди перезаписувати, якщо файли відрізняються$N⏭️: безумовно пропускати всі наявні файли", //m
 	"ut_mt": "продовжувати хешування інших файлів під час завантаження$N$Nможливо, вимкніть, якщо ваш CPU або HDD є вузьким місцем",
-	"ut_ask": 'запитати підтвердження перед початком завантаження">💭',
+	"ut_ask": 'запитати підтвердження перед початком завантаження',
 	"ut_pot": "покращити швидкість завантаження на повільних пристроях$Nроблячи інтерфейс менш складним",
 	"ut_srch": "не завантажувати, а перевірити, чи файли вже $N існують на сервері (сканує всі папки, які ви можете читати)",
@@ -226,5 +226,5 @@
 	"ct_grid": '田 сітка',
 	"ct_ttips": '◔ ◡ ◔">ℹ️ підказки',
-	"ct_thumb": 'у режимі сітки, перемкнути іконки або мініатюри$NГаряча клавіша: T">🖼️ мініатюри',
+	"ct_thumb": 'перемкнути іконки або мініатюри$NГаряча клавіша: T">🖼️ мініатюри',
 	"ct_csel": 'використовувати CTRL і SHIFT для вибору файлів у режимі сітки">вибір',
 	"ct_dsel": 'використовувати вибір перетягуванням у режимі сітки">перетягнути', //m
@@ -289,7 +289,7 @@
 	"ml_ss": "пропускати тишу", //m
 
-	"mt_loop": "зациклити/повторити одну пісню\">🔁",
+	"mt_loop": "зациклити/повторити одну пісню",
 	"mt_one": "зупинити після однієї пісні\">1️⃣",
-	"mt_shuf": "перемішати пісні в кожній папці\">🔀",
+	"mt_shuf": "перемішати пісні в кожній папці",
 	"mt_aplay": "автовідтворення, якщо є ID пісні в посиланні, по якому ви клацнули для доступу до сервера$N$Nвідключення цього також зупинить оновлення URL сторінки з ID пісень під час відтворення музики, щоб запобігти автовідтворенню, якщо ці налаштування втрачені, але URL залишається\">a▶",
 	"mt_preload": "почати завантаження наступної пісні ближче до кінця для безперервного відтворення\">preload",
@@ -306,6 +306,6 @@
 	"mt_compact": "компактні елементи керування\">⟎",
 	"mt_uncache": "очистити кеш &nbsp;(спробуйте це, якщо ваш браузер закешував$Nпошкоджену копію пісні, тому відмовляється її відтворювати)\">uncache",
-	"mt_mloop": "зациклити відкриту папку\">🔁 loop",
-	"mt_mnext": "завантажити наступну папку і продовжити\">📂 next",
+	"mt_mloop": "зациклити відкриту папку",
+	"mt_mnext": "завантажити наступну папку і продовжити",
 	"mt_mstop": "зупинити відтворення\">⏸ stop",
 	"mt_cflac": "конвертувати flac / wav в {0}\">flac",
diff -NarU2 a/copyparty/web/tl/vie.js b/copyparty/web/tl/vie.js
--- a/copyparty/web/tl/vie.js	2026-07-08 15:13:32.823924491 +0000
+++ b/copyparty/web/tl/vie.js	2026-07-28 23:09:10.628077022 +0000
@@ -3,5 +3,5 @@
 
 	"cols": {
-		"c": "nút hành động",
+		"!": "nút hành động",
 		"dur": "thời lượng",
 		"q": "chất lượng / bitrate",
@@ -12,5 +12,5 @@
 		"Vhash": "checksum video",
 		"Res": "độ phân giải",
-		"T": "loại tệp",
+		"Ext": "loại tệp",
 		"aq": "chất lượng âm thanh / bitrate",
 		"vq": "chất lượng video / bitrate",
@@ -31,5 +31,5 @@
 			["T", "chuyển đổi ảnh thu nhỏ / biểu tượng"],
 			["⇧ A/D", "kích thước ảnh thu nhỏ"],
-			["ctrl-K", "xoá mục đã chọn"],
+			["ctrl-K/Del", "xoá mục đã chọn"],
 			["ctrl-X", "cắt mục đã chọn vào bảng nhớ tạm"],
 			["ctrl-C", "sao chép mục đã chọn vào bảng nhớ tạm"],
@@ -103,7 +103,7 @@
 
 	"goh": "bảng điều khiển",
-	"gop": 'thư mục trước">trước',
-	"gou": 'thư mục cha">lên',
-	"gon": 'thư mục sau">tiếp',
+	"gop": 'thư mục trước',
+	"gou": 'thư mục cha',
+	"gon": 'thư mục sau',
 	"logout": "Đăng xuất ",
 	"login": "Đăng nhập",
@@ -155,5 +155,5 @@
 	"ut_ow": "ghi đè các tệp đã có trên máy chủ?$N🛡️: không bao giờ (sẽ tạo tên tệp mới)$N🕒: ghi đè nếu tệp trên máy chủ cũ hơn$N♻️: luôn ghi đè nếu hai tệp khác nhau$N⏭️: bỏ qua vô điều kiện tất cả các tệp hiện có", //m
 	"ut_mt": "tiếp tục hash các tệp khác trong khi tải lên$N$NCó thể tắt nếu CPU hoặc HDD của bạn bị nghẽn",
-	"ut_ask": 'yêu cầu xác nhận trước khi bắt đầu tải lên">💭',
+	"ut_ask": 'yêu cầu xác nhận trước khi bắt đầu tải lên',
 	"ut_pot": "cải thiện tốc độ tải lên trên các thiết bị chậm$Nbằng cách đơn giản hoá giao diện người dùng",
 	"ut_srch": "không tải lên, chỉ kiểm tra xem tệp$Nđã tồn tại trên máy chủ hay chưa (sẽ quét toàn bộ thư mục bạn có quyền đọc)",
@@ -227,5 +227,5 @@
 	"ct_grid": '田 chế độ lưới',
 	"ct_ttips": '༼ ◕_◕ ༽">ℹ️ tooltips',
-	"ct_thumb": 'ở chế độ lưới, chuyển biểu tượng hoặc hình thu nhỏ$NPhím tắt: T">🖼️ ảnh thu nhỏ',
+	"ct_thumb": 'chuyển biểu tượng hoặc hình thu nhỏ$NPhím tắt: T">🖼️ ảnh thu nhỏ',
 	"ct_csel": 'dùng CTRL và SHIFT để chọn tệp trong chế độ lưới">sel',
 	"ct_dsel": 'dùng chọn bằng cách kéo trong chế độ lưới">kéo', //m
@@ -293,7 +293,7 @@
 	"ml_ss": "bỏ qua khoảng lặng", //m
 
-	"mt_loop": "lặp lại một bài\">🔁",
+	"mt_loop": "lặp lại một bài",
 	"mt_one": "dừng sau một bài\">1️⃣",
-	"mt_shuf": "trộn các bài trong thư mụcr\">🔀",
+	"mt_shuf": "trộn các bài trong thư mụcr",
 	"mt_aplay": "tự động phát nếu có ID bài trong link bạn nhấp để truy cập máy chủ$N$Ntắt tuỳ chọn sẽ ngăn URL của trang cập nhật theo ID bài khi phát nhạc, tránh tự động phát nếu cài đặt mất nhưng URL còn\">a▶",
 	"mt_preload": "bắt đầu tải bài hát tiếp theo khi gần hết bài để phát liền mạch\">preload",
@@ -310,6 +310,6 @@
 	"mt_compact": "giao diện điều khiển thu gọn\">⟎",
 	"mt_uncache": "xoá bộ nhớ đệm &nbsp;(thử nếu trình duyệt lưu trữ đệm $Nmột bản nhạc bị lỗi và không thể phát)\">uncache",
-	"mt_mloop": "lặp trong thư mục đang mở\">🔁 loop",
-	"mt_mnext": "tải thư mục tiếp theo và tiếp tục\">📂 next",
+	"mt_mloop": "lặp trong thư mục đang mở",
+	"mt_mnext": "tải thư mục tiếp theo và tiếp tục",
 	"mt_mstop": "dừng phát\">⏸ stop",
 	"mt_cflac": "chuyển flac / wav sang {0}\">flac",
diff -NarU2 a/copyparty/web/up2k.js b/copyparty/web/up2k.js
--- a/copyparty/web/up2k.js	2026-07-28 23:16:17.540485393 +0000
+++ b/copyparty/web/up2k.js	2026-07-28 23:09:10.628391066 +0000
@@ -51,6 +51,19 @@
     }
     catch (ex) {
+        ebi('h_up2kcfg').style.display = 
+        ebi('u2btn_ct').style.display = 
+        ebi('u2c3t').style.display = 
+        ebi('up_info').style.display = 
+        ebi('opa_up').style.display = 
+            'none'
+
+        ebi('uq_up').onclick = function(){
+            modaltoggle('bup', true);
+            ebi('bup_btn').click();
+        }
+
         console.log('up2k init failed:', ex);
         toast.err(10, 'could not initialize up2k\n\n' + basenames(ex));
+
     }
 }
@@ -839,4 +852,5 @@
     var loading_deps = false;
     function init_deps() {
+        console.log('up2k init deps');
         if (!loading_deps && !got_deps()) {
             var fn = 'sha512.' + sha_js + '.js',
@@ -886,5 +900,5 @@
     }
 
-    setmsg(suggest_up2k, 'msg');
+    //setmsg(suggest_up2k, 'msg');
 
     var u2szs = u2sz.split(','),
@@ -919,5 +933,7 @@
     uc.owt = ['🛡️', '🕒', '♻️', '⏭️'];
     function set_ow() {
-        QS('label[for="u2ow"]').innerHTML = uc.owt[uc.ow];
+        var lbls = QSA('label[for="u2ow"]');
+        for(var i=0; i<lbls.length; i++)
+            lbls[i].innerHTML = uc.owt[uc.ow];
         ebi('u2ow').checked  = true; //cosmetic
     }
@@ -1030,5 +1046,5 @@
         modal.confirm(L.u_nav_m, uf, ud, null, L.u_nav_b);
     }
-    ebi('u2btn').onclick = nav;
+    ebi('uq_up').onclick = ebi('u2btn').onclick = nav;
 
     var nenters = 0;
@@ -1069,4 +1085,18 @@
         return onovercmn(this, e, true);
     }
+    function checkDropMode(){
+        if(ebi('fsearch').checked){
+            ebi('srch_zd').style.display = '';
+            ebi('up_zd').style.display = 'none';
+            ebi('srch_dz').style.display = '';
+            ebi('up_dz').style.display = 'none';
+        }
+        else{
+            ebi('srch_zd').style.display = 'none';
+            ebi('up_zd').style.display = '';
+            ebi('srch_dz').style.display = 'none';
+            ebi('up_dz').style.display = '';
+        }
+    }
     function onovercmn(self, e, btn) {
         var ok = false;
@@ -1074,4 +1104,10 @@
             var dt = e.dataTransfer.types;
 
+            for (var a = 0; a < dt.length; a++)
+                if(dt[a] == 'application/copyparty'){
+                    ev(e)
+                    return;
+                }
+
             for (var a = 0; a < dt.length && !ok; a++)
                 if (dt[a] == 'Files')
@@ -1082,5 +1118,5 @@
                     if (btn)
                         ok = true;
-                    else
+                    else if (!window.drag || !drag.no_warn)
                         return toast.inf(10, L.u_uri) || true;
                 }
@@ -1105,4 +1141,5 @@
             return;
 
+        checkDropMode();
         clmod(ebi('drops'), 'vis', 1);
         var v = self.getAttribute('v');
@@ -1118,4 +1155,5 @@
 
         if (--nenters <= 0) {
+            checkDropMode();
             clmod(ebi('drops'), 'vis');
             clmod(ebi('up_dz'), 'hl');
@@ -1132,4 +1170,6 @@
     ebi('u2btn').ondrop = gotfile;
     ebi('u2btn').ondragover = onoverbtn;
+    ebi('wrap').ondrop = gotfile;
+    ebi('wrap').ondragover = onover;
 
     var drops = [ebi('up_dz'), ebi('srch_dz')];
@@ -1174,10 +1214,22 @@
     function gotfile(e) {
         ev(e);
+
+        if (e.dataTransfer && e.dataTransfer.getData("text") && e.dataTransfer.getData("text").startsWith(window.location.origin)){
+			var currLink = e.dataTransfer.getData("text");
+			console.log("wrap.ondrop: " + currLink);
+			fileman.clip = currLink.split("\n");
+			
+			fileman.cut();
+			msel.evsel();
+            fileman.paste(true);
+            return
+		}
+
         nenters = 0;
         offdrag.call(this);
-        var dz = this && this.getAttribute('id');
-        if (!dz && e && e.clientY)
-            // cuo2duo fallback
-            dz = e.clientY < window.innerHeight / 2 ? 'up_dz' : 'srch_dz';
+        // var dz = this && this.getAttribute('id');
+        // if (!dz && e && e.clientY)
+        //     // cuo2duo fallback
+        //     dz = e.clientY < window.innerHeight / 2 ? 'up_dz' : 'srch_dz';
 
         var err = this.getAttribute('err');
@@ -1187,9 +1239,9 @@
         toast.inf(0, L.u_scan);
 
-        if ((dz == 'up_dz' && uc.fsearch) || (dz == 'srch_dz' && !uc.fsearch))
-            tgl_fsearch();
+        // if ((dz == 'up_dz' && uc.fsearch) || (dz == 'srch_dz' && !uc.fsearch))
+        //     tgl_fsearch();
 
-        if (!QS('#op_up2k.act'))
-            goto('up2k');
+        if(!uc.fsearch)
+            up2k.init_deps();
 
         var files,
@@ -2000,5 +2052,5 @@
             spd = Math.floor(st.bytes.finished / st.time.busy),
             suf = '\n\n{0} @ {1}/s'.format(shumantime(st.time.busy), humansize(spd)),
-            t = uc.ask_up ? 0 : 10;
+            t = 10; // uc.ask_up ? 0 : 10;
 
         console.log('toast', ok, ng);
@@ -3043,39 +3095,4 @@
     //
 
-    function onresize(e) {
-        // 10x faster than matchMedia('(min-width
-        var bar = ebi('ops'),
-            wpx = window.innerWidth,
-            fpx = parseInt(getComputedStyle(bar)['font-size']),
-            wem = wpx * 1.0 / fpx,
-            wide = wem > 57 ? 'w' : '',
-            parent = ebi(wide ? 'u2btn_cw' : 'u2btn_ct'),
-            btn = ebi('u2btn');
-
-        if (btn.parentNode !== parent) {
-            parent.appendChild(btn);
-            ebi('u2conf').className = ebi('u2cards').className = ebi('u2etaw').className = wide;
-        }
-
-        wide = wem > 86 ? 'ww' : wide;
-        parent = ebi(wide == 'ww' ? 'u2c3w' : 'u2c3t');
-        var its = [ebi('u2etaw'), ebi('u2cards')];
-        if (its[0].parentNode !== parent) {
-            ebi('u2conf').className = wide;
-            for (var a = 0; a < 2; a++) {
-                parent.appendChild(its[a]);
-                its[a].className = wide;
-            }
-        }
-    }
-    onresize100.add(onresize, true);
-
-    if (MOBILE) {
-        // android-chrome wobbles for a bit; firefox / iOS-safari are OK
-        setTimeout(onresize, 20);
-        setTimeout(onresize, 100);
-        setTimeout(onresize, 500);
-    }
-
     var o = QSA('#u2conf .c *[tt]');
     for (var a = o.length - 1; a >= 0; a--) {
@@ -3308,5 +3325,8 @@
         try {
             clmod(ebi('u2c3w'), 's', !can_write);
-            QS('label[for="fsearch"]').style.display = QS('#fsearch').style.display = fixed ? 'none' : '';
+            QS('#fsearch').style.display = fixed ? 'none' : '';
+            var lbls = QSA('label[for="fsearch"]');
+            for(var i=0; i<lbls.length; i++)
+                lbls[i].style.display = fixed ? 'none' : '';
         }
         catch (ex) { }
@@ -3317,4 +3337,5 @@
 
             clmod(ebi('op_up2k'), 'srch', uc.fsearch);
+            clmod(ebi('u2conf'), 'srch', uc.fsearch);
             ebi('u2bm').innerHTML = ico + '&nbsp; <sup>' + desc + '</sup>';
         }
@@ -3332,5 +3353,4 @@
         draw_turbo();
         draw_life();
-        onresize();
     }
 
@@ -3450,4 +3470,50 @@
     }, 1);
 
+
+    r.save_here = function () {
+        try{
+            window.shr_target = false
+            fileman.render();
+            // get data from sw.js
+            caches.open('/media').then(function(cache){
+				cache.match('/shared-file-count').then(function(r){
+                    return r && r.text()
+                }).then(function(count){
+                    if(!(count > 0)) return;
+                    cache.delete('/shared-file-count');
+
+                    var files = []
+                    function load_from_cache(i){
+                        if(i >= count){
+                            up_them(files);
+                            return;
+                        }
+                        cache.match('/shared-file-' + i).then(function(file){
+                            return file.blob()
+                        }).then(function(blob){
+                            cache.match('/shared-filename-' + i).then(function(nameR){
+                                return nameR && nameR.text()
+                            }).then(function(name){
+                                return name || 'shared_file_' + i
+                            }).then(function(name){
+                                var realFile = new File([blob], name, { type: blob.type });
+                                files.push([realFile, name]);
+                                load_from_cache(i + 1);
+                            }).then(function(){
+                                cache.delete('/shared-file-' + i);
+                                cache.delete('/shared-filename-' + i);
+                            });
+                        });
+                    }
+                    load_from_cache(0);
+                });
+			});
+        }
+        catch(e){
+            alert(e)
+        }
+    };
+    if(ebi('fsav')) ebi('fsav').onclick = r.save_here;
+
     return r;
 }
@@ -3464,6 +3530,6 @@
 favico.init();
 ebi('ico1').onclick = function () {
-    var a = favico.txt == this.textContent;
-    swrite('icot', a ? 'c' : this.textContent);
+    var a = favico.txt == '🎉';
+    swrite('icot', a ? 'c' : '🎉');
     swrite('icof', a ? 'fc5' : '000');
     swrite('icob', a ? '222' : '');
diff -NarU2 a/copyparty/web/util.js b/copyparty/web/util.js
--- a/copyparty/web/util.js	2026-07-08 15:13:32.824924219 +0000
+++ b/copyparty/web/util.js	2026-07-28 23:09:10.628617173 +0000
@@ -20,4 +20,10 @@
     Object.assign(window, window.CGV);
 
+function supportsEmoji() {
+    var ctx = document.createElement('canvas').getContext('2d');
+    ctx.canvas.width = ctx.canvas.height = 1;
+    ctx.fillText('🎉', -4, 4);
+    return ctx.getImageData(0, 0, 1, 1).data[3] > 0; // Checks if pixels were drawn
+}
 
 var wah = '',
@@ -36,4 +42,6 @@
     UA = '' + navigator.userAgent,
     IE = !!document.documentMode,
+    EMOJI = supportsEmoji(),
+    N3DS = /Nintendo 3DS/i.test(UA),
     FIREFOX = ('netscape' in window) && / rv:/.test(UA),
     IPHONE = TOUCH && /iPhone|iPad|iPod/i.test(UA),
@@ -42,5 +50,10 @@
     WINDOWS = /Windows/.test(UA),
     APPLE = IPHONE || MACOS,
-    APPLEM = TOUCH && APPLE;
+    APPLEM = TOUCH && APPLE,
+    PWA = window.matchMedia && window.matchMedia('(display-mode: minimal-ui)').matches;
+
+window.onpointerdown = function (e) {
+    TOUCH = e.pointerType === "touch";
+}
 
 if (!window.WebAssembly || !WebAssembly.Memory)
@@ -455,4 +468,9 @@
     head.appendChild(script);
 }
+function import_mjs(name, id) {
+    import_js(SR + "/.cpr/w/" + name + ".js", function () {
+        if (id) jsldp(id, name);
+    });
+}
 
 
@@ -778,5 +796,5 @@
 
 
-function linksplit(rp, base, id) {
+function linksplit(rp, base, id, flink) {
     var ret = [],
         apath = base || '/',
@@ -815,5 +833,5 @@
         }
 
-        ret.push('<a href="' + apath + link + '">' + vlink + '</a>');
+        ret.push('<a href="' + apath + link + '" class="' + (!rp ? 'flink' : '') + '">' + vlink + '</a>');
         apath += link;
     }
@@ -1336,6 +1354,10 @@
         return val;
 
-    if (o.getAttribute('type') == 'checkbox')
+    if (o.getAttribute('type') == 'checkbox'){
         o.checked = val;
+        var lbls = QSA('label[for="' + o.id +'"]');
+        for(var i=0; i<lbls.length; i++)
+            clmod(lbls[i], 'on', val);
+    }
     else if (o) {
         clmod(o, 'on', val);
@@ -1409,5 +1431,5 @@
 function sethash(hv) {
     if (window.history && history.replaceState) {
-        hist_replace(location.pathname + location.search + '#' + hv);
+        hist_replace(location.pathname + location.search + (hv ? '#' : '') + hv);
     }
     else {
@@ -1602,4 +1624,16 @@
     };
 
+    r.parse = function(msg){
+        if(msg == null || msg.length == 0)
+            return msg;
+        if (msg.startsWith('`')) {
+            var x = false;
+            msg = msg.slice(1);
+            while (msg.indexOf('`') + 1)
+                msg = msg.replace('`', (x = !x) ? '<code>' : '</code>');
+        }
+        return msg.replace(/\$N/g, "<br />");
+    }
+
     r.show = function () {
         clearTimeout(tev);
@@ -1612,11 +1646,4 @@
             return;
 
-        if (msg.startsWith('`')) {
-            var x = false;
-            msg = msg.slice(1);
-            while (msg.indexOf('`') + 1)
-                msg = msg.replace('`', (x = !x) ? '<code>' : '</code>')
-        }
-
         r.el = this;
         var pos = this.getBoundingClientRect(),
@@ -1634,5 +1661,5 @@
         r.tt.style.top = '0';
 
-        r.tt.innerHTML = msg.replace(/\$N/g, "<br />");
+        r.tt.innerHTML = r.parse(msg);
         r.el.addEventListener('mouseleave', r.hide);
         window.addEventListener('scroll', r.hide);
@@ -1655,4 +1682,8 @@
     r.hide = function (e) {
         //ev(e);  // eats checkbox-label clicks
+
+        r.show.bind(null);
+        r.el = null;
+
         clearTimeout(tev);
         window.removeEventListener('scroll', r.hide);
@@ -1748,4 +1779,6 @@
         obj = mknod('div', 'toast');
 
+    clmod(obj, 'hide', true);
+
     document.body.appendChild(obj);
     r.visible = false;
@@ -1828,5 +1861,5 @@
             html += '<div id="toastt"></div>';
         }
-        obj.innerHTML = html + '<a href="#" id="toastc">x</a><div id="toastb">' + lf2br(txt) + '</div>';
+        obj.innerHTML = html + '<a href="#" id="toastc"><span class="x">×</span></a><div id="toastb">' + lf2br(txt) + '</div>';
         obj.className = cl;
         sec += obj.offsetWidth;
@@ -2276,5 +2309,5 @@
     var gx = function (txt) {
         return (svg_decl +
-            '<svg version="1.1" viewBox="0 0 64 64" xmlns="http://www.w3.org/2000/svg">\n' +
+            '<svg version="1.1" viewBox="0 0 70 70" xmlns="http://www.w3.org/2000/svg">\n' +
             (r.bg ? '<rect width="100%" height="100%" rx="16" fill="#' + r.bg + '" />\n' : '') +
             '<text x="50%" y="55%" dominant-baseline="middle" text-anchor="middle"' +
@@ -2313,4 +2346,9 @@
         }
         r.tag.href = 'data:image/svg+xml;base64,' + b64;
+
+        var fiop = ebi('favico_onpage');
+        if(fiop != null){
+            fiop.innerHTML = svg ? atob(b64) : gx(r.txt);
+        }
     };
 
@@ -2336,4 +2374,68 @@
 }
 
+// read accent / theme color
+function parseColor (strColor) {
+    if(strColor && strColor.length > 0 && strColor.length <= 8 && !strColor.startsWith('#') && !strColor.match(",")) 
+        strColor = '#' + strColor;
+	var s = new Option().style;
+	s.color = strColor;
+	return s.color !== '' ? s.color : '';
+}
+function setColor (color, temp) {
+    if(color == '#333333' || color == 'rgb(51, 51, 51)') color = '';
+	accent = color;
+    if(!temp)
+	    swrite('paccent', accent);
+	var a = accent || '';
+	console.log('accent color set to: ' + a);
+	setcvar('--a', a);
+	pbar.drawbuf();
+	pbar.drawpos();
+	vbar.draw();
+}
+
+var accent = sread('paccent');
+var tcolor = QS('meta[name=theme-color]');
+if(tcolor)
+    tcolor = tcolor.content;
+if((!accent || accent.length <= 3) && tcolor != "#333333")
+    accent = tcolor;
+if(accent && accent.length > 3){
+    console.log('read accent color from settings: ' + accent);
+    setcvar('--a', parseColor(accent));
+}
+
+var HAS_BG = false
+var setBg = function(bg){
+    var bgv = ebi('bg_vid'),
+        re_v = /^[^?]+\.(webm|mkv|mp4|m4v|mov)(\?|$)/i,
+        isVid = false,
+        src;
+    HAS_BG = bg != '' && bg !== true;
+    if(sread('enbg') == 0) bg = '';
+    console.log('setting bg to: ' + (bg || 'none'))
+    if(bg && bg !== true){
+        var parts = bg.split(',');
+        if(parts){
+            isVid = re_v.test(parts[0])
+            src = parts[0]
+        }
+        for(var i = 0; i < parts.length; i++){
+            if(parts[i].match('=')){
+                var o = parts[i].split('=')
+                if(o[0].trim() == 'blur')
+                    o[1] = 'blur(' + o[1] + 'px)'
+                setcvar('--bg-' + o[0].trim(), o[1])
+            }
+        }
+    }
+    setcvar('--bg-img', !isVid && src ? ('url("' + src + '")') : '');
+    if(bgv){
+        clmod(bgv, 'vis', isVid);
+        if(isVid)
+            bgv.innerHTML = '<source src="' + src + '" type="video/mp4"/>';
+    }
+}
+setBg(window.bg_img);
 
 function bchrome() {
@@ -2343,5 +2445,5 @@
 
     try {
-        v = cprop('--bg-u3');
+        v = cprop('--a');
     }
     catch (ex) { }
@@ -2411,3 +2513,15 @@
 }
 
+function jsldp(a, b) {
+	2 != window[a] && alert("FATAL ERROR: cannot load " + b + ".js due to unreliable network or broken reverse-proxy; try CTRL-SHIFT-R");
+}
+
+// polyfill for 3DS (IE11 can do this natively)
+var MouseEvent = MouseEvent ? MouseEvent : function (eventType, e) {
+	e = e || { bubbles: false, cancelable: false };
+	var mouseEvent = document.createEvent('MouseEvent');
+	mouseEvent.initMouseEvent(eventType, e.bubbles, e.cancelable, window, 0, 0, 0, 0, false, false, false, false, 0, null);
+	return mouseEvent;
+};
+
 J_UTL = 2;
diff -NarU2 a/scripts/make-sfx.sh b/scripts/make-sfx.sh
--- a/scripts/make-sfx.sh	2026-07-28 23:16:17.541485410 +0000
+++ b/scripts/make-sfx.sh	2026-07-13 09:49:10.696380106 +0000
@@ -406,6 +406,15 @@
 		exit 1
 	}
-
 	dt="$(git log -1 --format=%cd --date=short | sed -E 's/-0?/, /g')"
+}
+
+[ "$PRTY_SFX_VER" ] && {
+	# PRTY_SFX_VER='1.20.14-5-g139ef185' PRTY_SFX_DT='2026, 5, 8'
+	# PRTY_SFX_VER='2026-0510-2303' PRTY_SFX_DT='2026, 5, 10'
+	ver="$PRTY_SFX_VER"
+	dt="$PRTY_SFX_DT"
+}
+
+[ "$ver" ] && {
 	printf 'git %3s: \033[36m%s\033[0m\n' ver "$ver" dt "$dt"
 	sed -ri '
diff -NarU2 a/scripts/sfx.ls b/scripts/sfx.ls
--- a/scripts/sfx.ls	2026-07-28 23:16:17.542485428 +0000
+++ b/scripts/sfx.ls	2026-07-28 23:14:14.887600789 +0000
@@ -75,5 +75,9 @@
 copyparty/web/browser2.html,
 copyparty/web/cf.html,
+copyparty/web/config.css,
+copyparty/web/config.html,
+copyparty/web/config.js,
 copyparty/web/copyparty.gif,
+copyparty/web/copyparty.svg,
 copyparty/web/deps,
 copyparty/web/deps/__init__.py,
@@ -94,4 +98,5 @@
 copyparty/web/idp.html,
 copyparty/web/iiam.gif,
+copyparty/web/manifest.json,
 copyparty/web/md.css,
 copyparty/web/md.html,
@@ -116,4 +121,5 @@
 copyparty/web/svcs.html,
 copyparty/web/svcs.js,
+copyparty/web/sw.js,
 copyparty/web/tl,
 copyparty/web/tl/chi.js,
diff -NarU2 a/scripts/tl.js b/scripts/tl.js
--- a/scripts/tl.js	2026-07-08 15:13:32.832902264 +0000
+++ b/scripts/tl.js	2026-07-28 23:09:10.629020886 +0000
@@ -38,5 +38,5 @@
 
 	"cols": {
-		"c": "action buttons",
+		"!": "action buttons",
 		"dur": "duration",
 		"q": "quality / bitrate",
@@ -47,5 +47,5 @@
 		"Vhash": "video checksum",
 		"Res": "resolution",
-		"T": "filetype",
+		"Ext": "filetype",
 		"aq": "audio quality / bitrate",
 		"vq": "video quality / bitrate",
@@ -66,5 +66,5 @@
 			["T", "toggle thumbnails / icons"],
 			["⇧ A/D", "thumbnail size"],
-			["ctrl-K", "delete selected"],
+			["ctrl-K/Del", "delete selected"],
 			["ctrl-X", "cut selection to clipboard"],
 			["ctrl-C", "copy selection to clipboard"],
@@ -140,7 +140,7 @@
 
 	"goh": "control-panel",
-	"gop": 'previous sibling">prev',
-	"gou": 'parent folder">up',
-	"gon": 'next folder">next',
+	"gop": 'previous sibling',
+	"gou": 'parent folder',
+	"gon": 'next folder',
 	"logout": "Logout ",
 	"login": "Login",
@@ -190,5 +190,5 @@
 	"ut_ow": "overwrite existing files on the server?$N🛡️: never (will generate a new filename instead)$N🕒: overwrite if server-file is older than yours$N♻️: always overwrite if the files are different$N⏭️: unconditionally skip all existing files",
 	"ut_mt": "continue hashing other files while uploading$N$Nmaybe disable if your CPU or HDD is a bottleneck",
-	"ut_ask": 'ask for confirmation before upload starts">💭',
+	"ut_ask": 'ask for confirmation before upload starts',
 	"ut_pot": "improve upload speed on slow devices$Nby making the UI less complex",
 	"ut_srch": "don't actually upload, instead check if the files already $N exist on the server (will scan all folders you can read)",
@@ -238,10 +238,10 @@
 	"u_nav_b": '<a href="#" id="modal-ok">Files</a><a href="#" id="modal-ng">One folder</a>',
 
-	"cl_opts": "switches",
+	"cl_opts": "general",
 	"cl_hfsz": "filesize",
 	"cl_themes": "theme",
 	"cl_langs": "language",
 	"cl_ziptype": "folder download",
-	"cl_uopts": "up2k switches",
+	"cl_uopts": "upload",
 	"cl_favico": "favicon",
 	"cl_bigdir": "big dirs",
@@ -257,5 +257,5 @@
 	"ct_grid": '田 the grid',
 	"ct_ttips": '◔ ◡ ◔">ℹ️ tooltips',
-	"ct_thumb": 'in grid-view, toggle icons or thumbnails$NHotkey: T">🖼️ thumbs',
+	"ct_thumb": 'toggle icons or thumbnails$NHotkey: T">🖼️ thumbs',
 	"ct_csel": 'use CTRL and SHIFT for file selection in grid-view">sel',
 	"ct_dsel": 'use drag-selection in grid-view">dsel',
@@ -318,5 +318,5 @@
 	"ml_ss": "skip silence",
 
-	"mt_loop": "loop/repeat one song\">🔁",
+	"mt_loop": "loop/repeat one song",
 	"mt_one": "stop after one song\">1️⃣",
 	"mt_shuf": "shuffle the songs in each folder\">🔀",
@@ -336,5 +336,5 @@
 	"mt_uncache": "clear cache &nbsp;(try this if your browser cached$Na broken copy of a song so it refuses to play)\">uncache",
 	"mt_mloop": "loop the open folder\">🔁 loop",
-	"mt_mnext": "load the next folder and continue\">📂 next",
+	"mt_mnext": "load the next folder and continue",
 	"mt_mstop": "stop playback\">⏸ stop",
 	"mt_cflac": "convert flac / wav to {0}\">flac",
@@ -548,4 +548,5 @@
 	"s_t1": "tags contains &nbsp; (^=start, end=$)",
 	"s_a1": "specific metadata properties",
+	"s_dir": "search this folder",
 
 	"md_eshow": "cannot render ",
